'
' frmTestSpeed    Gui Application
'
''pre cmd tiny run noenc noopt exe nocon kill nobk gico diricon 'output 'upx
DefStr BuildCount = "0.087" ''pre + 0.001 3
DefStr FirstCompiled  =  "06-05-2008  18:35:02"
''pre end
'
$ESCAPECHARS ON
$TYPECHECK ON
$INCLUDE "RAPIDQ.INC"
'
Declare Sub OnClose_frmTestSpeed
'
Create frmTestSpeed As QForm
    Center
    Width = 1000
    height = 600
    Caption = "frmTestSpeed"
    AutoScroll = False
    OnClose = OnClose_frmTestSpeed
    Create rchWin AS QRichEdit
        Align = 5
        Font.Name = "courier"    
        Font.Size = 8
        Font.Color = &H800000
        ReadOnly = True
        WordWrap = False
        ScrollBars = ssBoth
        HideSelection = False 
        PlainText = True
    End Create
End Create
'
' --------------------------------------------------------------------
' New Code API Call that lets RapidQ programs minimize to the task bar
DECLARE FUNCTION SetWindowLong LIB "user32" ALIAS "SetWindowLongA" (hWnd AS LONG, _
                                               nIndex AS LONG, dwNewLong AS LONG) AS LONG
'      ----- API Constants and Functions
CONST GWL_HWNDPARENT = (-8)                   'Minimize to task bar
CONST HWND_DESKTOP = 0
setwindowlong(frmTestSpeed.handle, GWL_HWNDPARENT, HWND_DESKTOP)
setwindowlong(application.handle, GWL_HWNDPARENT, frmTestSpeed.handle)
' --------------------------------------------------------------------
'
' *************************************
frmTestSpeed.Show
' *************************************
'
$Define Glint Integer
'
Dim X As Glint
Dim Y As Glint
'
DIM A?(1023,1023)
DIM W?(1023,1023)
DIM Z%(1024,1024)
DIM Q AS SHORT
DIM Z AS SHORT
DIM YY AS SHORT
DIM NDM AS BYTE
NDM = 128
DIM SeaLevel AS BYTE
'
SUB MoveSeaLevel
    NDM=SeaLevel
    FOR X = 0 TO 1023
    FOR Y = 0 TO 1023
    W?(X, Y) = 0: IF A?(X, Y) > NDM THEN W?(X, Y) = 255
    NEXT Y: NEXT X
END SUB
'
SUB InvertHeightMap
    FOR X = 0 TO 1023
    FOR Y = 0 TO 1023
    Z%(X, Y) = 1023 - Z%(X, Y)
    A?(X, Y) = Z%(X, Y)\4
    W?(X, Y) = 0: IF A?(X, Y) > NDM THEN W?(X, Y) = 255
    NEXT Y: NEXT X
END SUB
'
SUB SwapRows
    DIM TEMP?
    FOR X = 0 TO 511
    FOR Y = 0 TO 1023
        TEMP? = A?(X,Y)
    A?(X,Y) = A?(1023-X,Y)
    A?(1023-X,Y) = TEMP?
    NEXT Y:NEXT X
END SUB
'
DefSng sngChrono, sngRQTime, sngFBTime, sngGCCTime
DefInt iRet
'
' Shows some values in the array to check initialize, ... works
Sub QuickCheckArray ()
    rchWin.AddString "\nptr(0, 1) : " & Str$(VarPtr(A?(0,1)))             &  "  (check : 1 = " & Str$(A?(0,1)) & ")"
    rchWin.AddString   "ptr(0, 2) : " & Str$(VarPtr(A?(0,2)))             &  "  (check : 2 = " & Str$(A?(0,2)) & ")"
    rchWin.AddString   "ptr(0, 0) : " & Str$(VarPtr(A?(0,0)))             &  "  (check : 0 = " & Str$(A?(0,0)) & ")"
    rchWin.AddString   "ptr(1, 0) : " & Str$(VarPtr(A?(1,0)))             &  "  (check : 1 = " & Str$(A?(1,0)) & ")"
    rchWin.AddString   "ptr(2, 0) : " & Str$(VarPtr(A?(2,0)))             &  "  (check : 2 = " & Str$(A?(2,0)) & ")"
    rchWin.AddString   "ptr(1023, 1023) : " & Str$(VarPtr(A?(1023,1023))) _
                           &  "  (check : " & Str$((1023 + 1023) And &HFF) & " = " & Str$(A?(1023,1023))     & ")\n"
    DoEvents
End Sub
'
' these 2 $include must be here after Dim ... As Byte, ??? Byte erroneously
' alloctes memory ???' otherwise it bugs ????????????
$Include "FB_Funcs.Inc" 
$Include "GCC_Funcs.Inc"
'
' Initialize Array
' ++++++++++++++++
rchWin.Addstring "Wait: Initializig Array ... "
'
' RQ
' --
sngChrono = Timer 
FOR X = 0 TO 1023
    FOR Y = 0 TO 1023
        A?(X, Y) = (X + Y) And &HFF
    NEXT Y
NEXT X
sngRqTime = Timer - sngChrono
rchWin.AddString ("\nInitialize array RQ  Time : " & Strf$(sngRqTime, ffNumber, 7, 5) & " s")
DoEvents
'
' QuickCheckArray
'
iRet = GCC_ZeroArray(VarPtr(A?(0,0)), 0, 0, 0)
'
' FB
' --
sngChrono = Timer
iRet = FB_InitRQArray(VarPtr(A?(0,0)), 0, 0, 0)
sngFbTime = Timer - sngChrono
rchWin.AddString ("Initialize array FB  Time : " & Strf$(sngFbTime, ffNumber, 7, 5) & " s" _
                               & "    " & Strf$(sngRqTime/sngFbTime, ffNumber, 7, 2) & " x Faster")
DoEvents
'
' QuickCheckArray
'
iRet = GCC_ZeroArray(VarPtr(A?(0,0)), 0, 0, 0)
'
' C++
' ---
sngChrono = Timer
iRet = GCC_InitRQArray(VarPtr(A?(0,0)), 0, 0, 0)
sngGccTime = Timer - sngChrono
rchWin.AddString ("Initialize array GCC Time : " & Strf$(sngGccTime, ffNumber, 7, 5) & " s" _
                            & "    " & Strf$(sngRqTime/sngGccTime, ffNumber, 7, 2) & " x Faster\n")
DoEvents
'
' QuickCheckArray
'
iRet = GCC_ZeroArray(VarPtr(A?(0,0)), 0, 0, 0)
'
' MoveSeaLevel
' ++++++++++++ 
rchWin.Addstring "Wait: Testing MoveSeaLevel Function ... "
'
' RQ
' --
sngChrono = Timer
MoveSeaLevel
sngRqTime = Timer - sngChrono
rchWin.AddString ("\n    MoveSeaLevel RQ  Time : " & Strf$(sngRqTime, ffNumber, 7, 5) & " s")
DoEvents
'
' FB
' --
NDM=SeaLevel
sngChrono = Timer
iRet = FB_MOVESEALEVEL(Varptr(W?(0, 0)), VarPtr(A?(0,0)), Varptr(NDM), 0)
sngFbTime = Timer - sngChrono
rchWin.AddString ("    MoveSeaLevel FB  Time : " & Strf$(sngFbTime, ffNumber, 7, 5) & " s" _
                            & "    " & Strf$(sngRqTime/sngFbTime, ffNumber, 7, 2) & " x Faster")
DoEvents
'
' GCC
' ---
NDM=SeaLevel
sngChrono = Timer
iRet = GCC_MOVESEALEVEL(Varptr(W?(0, 0)), VarPtr(A?(0,0)), Varptr(NDM), 0)
sngGccTime = Timer - sngChrono
rchWin.AddString ("    MoveSeaLevel GCC Time : " & Strf$(sngGccTime, ffNumber, 7, 5) & " s" _
                         & "    " & Strf$(sngRqTime/sngGccTime, ffNumber, 7, 2) & " x Faster\n")
DoEvents
'
' InvertHeightMap
' +++++++++++++++
rchWin.Addstring "Wait: Testing InvertHeightMap Function ... "
'
' RQ
' ---
sngChrono = Timer
InvertHeightMap
sngRqTime = Timer - sngChrono
rchWin.AddString ("\n InvertHeightMap RQ  Time : " & Strf$(sngRqTime, ffNumber, 7, 5) & " s")
DoEvents
'
' FB
' --
sngChrono = Timer
iRet = FB_InvertHeightMap (Varptr(Z%(0, 0)), VarPtr(A?(0,0)), VarPtr(W?(0,0)), Varptr(NDM))
sngFbTime = Timer - sngChrono
rchWin.AddString (  " InvertHeightMap FB  Time : " & Strf$(sngFbTime, ffNumber, 7, 5) & " s" _
                             & "    " & Strf$(sngRqTime/sngFbTime, ffNumber, 7, 2) & " x Faster")
DoEvents
'
' GCC
' ---
sngChrono = Timer
iRet = GCC_InvertHeightMap (Varptr(Z%(0, 0)), VarPtr(A?(0,0)), VarPtr(W?(0,0)), Varptr(NDM))
sngGccTime = Timer - sngChrono
rchWin.AddString (  " InvertHeightMap GCC Time : " & Strf$(sngGccTime, ffNumber, 7, 5) & " s" _
                          & "    " & Strf$(sngRqTime/sngGccTime, ffNumber, 7, 2) & " x Faster\n")
DoEvents
'
' SwapRows
' ++++++++
rchWin.Addstring "Wait: Testing SwapRows Function ... "'
' RQ
' --
sngChrono = Timer
SwapRows
sngRqTime = Timer - sngChrono
rchWin.AddString ("\n        SwapRows RQ  Time : " & Strf$(sngRqTime, ffNumber, 7, 5) & " s")
DoEvents
'
' FB
' --
sngChrono = Timer
iRet = FB_SwapRows(VarPtr(A?(0, 0)), 0, 0, 0)
sngFbTime = Timer - sngChrono
rchWin.AddString (  "        SwapRows FB  Time : " & Strf$(sngFbTime, ffNumber, 7, 5) & " s" _
                            & "    " & Strf$(sngRqTime/sngFbTime, ffNumber, 7, 2) & " x Faster")
DoEvents
'
' GCC
' ---
sngChrono = Timer
iRet = GCC_SwapRows(VarPtr(A?(0, 0)), 0, 0, 0)
sngGccTime = Timer - sngChrono
rchWin.AddString (  "        SwapRows GCC Time : " & Strf$(sngGccTime, ffNumber, 7, 5) & " s" _
                          & "    " & Strf$(sngRqTime/sngGccTime, ffNumber, 7, 2) & " x Faster\n")
DoEvents
'
' FINISHED
' ++++++++
rchWin.Addstring "\n\n      FINISHED\n\n"
'
' *************************************
frmTestSpeed.Visible = False
frmTestSpeed.ShowModal
' ************************************* 
'
Sub OnClose_frmTestSpeed
    Application.Terminate
End Sub
'
